#****************************************************************************
#**
#**  File     :  /cdimage/units/UEB2301/UEB2301_script.lua
#**  Author(s):  John Comes, David Tomandl, Jessica St. Croix
#**
#**  Summary  :  UEF Heavy Gun Tower Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TStructureUnit = import('/lua/terranunits.lua').TStructureUnit
local TDFGaussCannonWeapon = import('/lua/terranweapons.lua').TDFGaussCannonWeapon
-- fr enhancements
local CWalkingLandUnit = import('/lua/cybranunits.lua').CWalkingLandUnit
local Buff = import('/lua/sim/Buff.lua')


KHD0001 = Class(TStructureUnit) {
    Weapons = {
        Gauss01 = Class(TDFGaussCannonWeapon) {},      
    },
	
	OnStopBeingBuilt = function(self,builder,layer)
	TStructureUnit.OnStopBeingBuilt(self,builder,layer)
	self:SetReclaimable(false)
	local position = self:GetPosition()
	
	
	end,
	
	# ************
    # Enhancements
    # ************
    CreateEnhancement = function(self, enh)
        CWalkingLandUnit.CreateEnhancement(self, enh)
        local bp = self:GetBlueprint().Enhancements[enh]
        if not bp then return end
		
        if enh == 'DamageUpgrade' then
            local wep = self:GetWeaponByLabel('Gauss01')
            wep:AddDamageMod(self:GetBlueprint().Enhancements.DamageUpgrade.NewDamageMod or 0)
			
		 elseif enh == 'DamageUpgrade2' then
            local wep = self:GetWeaponByLabel('Gauss01')
            wep:AddDamageMod(self:GetBlueprint().Enhancements.DamageUpgrade2.NewDamageMod or 0)
			
			elseif enh == 'DamageUpgrade3' then
            local wep = self:GetWeaponByLabel('Gauss01')
            wep:AddDamageMod(self:GetBlueprint().Enhancements.DamageUpgrade3.NewDamageMod or 0)
			
			elseif enh == 'DamageUpgrade4' then
            local wep = self:GetWeaponByLabel('Gauss01')
            wep:AddDamageMod(self:GetBlueprint().Enhancements.DamageUpgrade4.NewDamageMod or 0)
			
			elseif enh == 'HealthUpgrade' then
            self:SetMaxHealth(20000)
			local currenthealth = self:GetHealth()
			self:SetHealth(self, currenthealth+10000)
			
			elseif enh == 'HealthUpgrade2' then
            self:SetMaxHealth(30000)
			local currenthealth = self:GetHealth() 
			self:SetHealth(self, currenthealth+10000)
			
			elseif enh == 'HealthUpgrade3' then
            self:SetMaxHealth(40000)
			local currenthealth = self:GetHealth() 
			self:SetHealth(self, currenthealth+10000)
			
			elseif enh == 'HealthUpgrade4' then
            self:SetMaxHealth(50000)
			local currenthealth = self:GetHealth() 
			self:SetHealth(self, currenthealth+10000)
			
		
           
        end		
    end,
	
	DeathThread = function( self, overkillRatio)
		self:HideBone('UEB2301', true)
		local explosion = import('/lua/defaultexplosions.lua')
		self:DestroyAllDamageEffects()
		
		self:ForkThread(self.Spawnthread);
		
		
		
		
		
		
	end,
	
	Spawnthread = function(self)
		local army = self:GetArmy()
		
		local position = self:GetPosition()
		WaitSeconds(180);
		
		if ArmyIsOutOfGame(self:GetArmy()) == false then
		spiritUnit = CreateUnitHPR('KHD0001', self:GetArmy(), position[1], position[2], position[3], 0, 0, 0);
		end
		self:Destroy()
	end,
}

TypeClass = KHD0001