#****************************************************************************
#**
#**  File     :  /cdimage/units/UEB2301/UEB2301_script.lua
#**  Author(s):  John Comes, David Tomandl, Jessica St. Croix
#**
#**  Summary  :  UEF Heavy Gun Tower Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TStructureUnit = import('/lua/terranunits.lua').TStructureUnit
local CDFParticleCannonWeapon = import('/lua/cybranweapons.lua').CDFParticleCannonWeapon
KHD0002 = Class(TStructureUnit) {
    Weapons = {
        MainGun = Class(CDFParticleCannonWeapon) {
            FxMuzzleFlash = {'/effects/emitters/particle_cannon_muzzle_02_emit.bp'},
        },     
    },
	OnCreate = function (self, builder, layer)
	TStructureUnit.OnCreate(self, builder, layer)
	self:SetReclaimable(false)
	end,
	
	
	DeathThread = function( self, overkillRatio)
		self:HideBone('URB2301', true)
		local explosion = import('/lua/defaultexplosions.lua')
		self:DestroyAllDamageEffects()
		
		self:ForkThread(self.Spawnthread);
		
		
		
		
		
	end,
	
	Spawnthread = function(self)
		local army = self:GetArmy()
		
		local position = self:GetPosition()
		WaitSeconds(180);
		
		if ArmyIsOutOfGame(self:GetArmy()) == false then
		spiritUnit = CreateUnitHPR('KHD0002', self:GetArmy(), position[1], position[2], position[3], 0, 0, 0);
		end
		self:Destroy()
	end,
	
}

TypeClass = KHD0002