#****************************************************************************
#**
#**  File     :  /cdimage/units/UEB0304/UEB0304_script.lua
#**  Author(s):  John Comes, David Tomandl, Gordon Duclos
#**
#**  Summary  :  UEF Quantum Gate Script
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local TQuantumGateUnit = import('/lua/terranunits.lua').TQuantumGateUnit
local EffectUtil = import('/lua/EffectUtilities.lua')
local EffectTemplate = import('/lua/EffectTemplates.lua')
local tqgatesdone = false
local tACUKillsdone  = false
textprinted = false

UEL0001 = Class(TQuantumGateUnit) {

	GateEffectVerticalOffset = 0.35,
	GateEffectScale = 0.42,
	
	
	
	
	OnStopBeingBuilt = function(self,builder,layer)
	    #ScenarioInfo.Options.Victory = 'sandbox'
        self.GateEffectEntity = import('/lua/sim/Entity.lua').Entity()
        self.GateEffectEntity:AttachBoneTo(-1, self,'UEB0304')
        self.GateEffectEntity:SetMesh('/effects/entities/ForceField01/ForceField01_mesh')
        self.GateEffectEntity:SetDrawScale(self.GateEffectScale)
        self.GateEffectEntity:SetParentOffset(Vector(0,0,self.GateEffectVerticalOffset))
        self.GateEffectEntity:SetVizToAllies('Intel')
        self.GateEffectEntity:SetVizToNeutrals('Intel')
        self.GateEffectEntity:SetVizToEnemies('Intel')          
        self.Trash:Add(self.GateEffectEntity)
		self:SetReclaimable(false)
        CreateAttachedEmitter(self,'Left_Gate_FX',self:GetArmy(),'/effects/emitters/terran_gate_01_emit.bp')
        CreateAttachedEmitter(self,'Right_Gate_FX',self:GetArmy(),'/effects/emitters/terran_gate_01_emit.bp')
                self:SetReclaimable(false)
        TQuantumGateUnit.OnStopBeingBuilt(self, builder, layer)
		
		local position = self:GetPosition()
        local spiritUnit = CreateUnitHPR('KHL0001', self:GetArmy(), position[1], position[2], position[3]+5, 0, 0, 0)
        
     	local Antiair = CreateUnitHPR('INU2004', self:GetArmy(), position[1], position[2], position[3]-7, 0, 0, 0)	
		local spiritUnit1 = CreateUnitHPR('KHL0010', self:GetArmy(), position[1], position[2], position[3]-5, 0, 0, 0)
		local defense1 = CreateUnitHPR('KHD0001', self:GetArmy(), position[1]+7, position[2], position[3], 0, 0, 0)
		local defense1 = CreateUnitHPR('KHD0001', self:GetArmy(), position[1]-7, position[2], position[3], 0, 0, 0)
		local airdefense1 = CreateUnitHPR('KHD0002', self:GetArmy(), position[1]+7, position[2], position[3]+2, 0, 0, 0)
		local airdefense2 = CreateUnitHPR('KHD0002', self:GetArmy(), position[1]+7, position[2], position[3]-2, 0, 0, 0)
		local airdefense3 = CreateUnitHPR('KHD0002', self:GetArmy(), position[1]-7, position[2], position[3]+2, 0, 0, 0)
		local airdefense4 = CreateUnitHPR('KHD0002', self:GetArmy(), position[1]-7, position[2], position[3]-2, 0, 0, 0)
		
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]-10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0201', self:GetArmy(), position[1]+10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0103', self:GetArmy(), position[1]-10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0103', self:GetArmy(), position[1]-10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0103', self:GetArmy(), position[1]-10, position[2], position[3]+10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0103', self:GetArmy(), position[1]+10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0103', self:GetArmy(), position[1]+10, position[2], position[3]-10, 0, 0, 0)
		local initialarmy = CreateUnitHPR('UEL0103', self:GetArmy(), position[1]+10, position[2], position[3]-10, 0, 0, 0)
		self:ForkThread(self.CreateTable)
		self:ForkThread(self.GiveInitialResources)
		self:ForkThread(self.UpgradeHealth)
    end,
	

	CreateTable = function(self)
		
		WaitSeconds(10)
		local army = self:GetArmy()
		
		table.insert(_G.QuantumGates.Positions,army,self:GetPosition())
		LOG(_G.QuantumGates.Positions)
		
		
		
	end,
	
	GiveInitialResources = function(self)
        WaitTicks(5)
        self:GetAIBrain():GiveResource('Energy', 1500)
        self:GetAIBrain():GiveResource('Mass', 400)
    end,
	
	UpgradeHealth = function(self)
		WaitSeconds(300)
		self:SetMaxHealth(225000)
			local currenthealth = self:GetHealth()
			self:SetHealth(self, currenthealth+25000)
		WaitSeconds(300)
		self:SetMaxHealth(250000)
			local currenthealth = self:GetHealth()
			self:SetHealth(self, currenthealth+25000)
		WaitSeconds(600)
		self:SetMaxHealth(300000)
			local currenthealth = self:GetHealth()
			self:SetHealth(self, currenthealth+50000)
		WaitSeconds(600)
		self:SetMaxHealth(350000)
			local currenthealth = self:GetHealth()
			self:SetHealth(self, currenthealth+50000)
		WaitSeconds(600)
		self:SetMaxHealth(400000)
			local currenthealth = self:GetHealth()
			self:SetHealth(self, currenthealth+50000)
		WaitSeconds(600)
		self:SetMaxHealth(500000)
			local currenthealth = self:GetHealth()
			self:SetHealth(self, currenthealth+100000)
	end,
	
	PlayCommanderWarpInEffect = function(self)
        #self:HideBone(0, true)
		
        self:SetUnSelectable(true)
        self:SetBusy(true)
        self:SetBlockCommandQueue(true)
        self:ForkThread(self.WarpInEffectThread)
		self:ForkThread(self.Print)
    end,
	
	Print = function(self)
		WaitSeconds(2)
	    if textprinted == false then
		PrintText('Be a Hero!', 30, 'ffff2020', 4, 'center')
		textprinted = true
		end
	end,

    WarpInEffectThread = function(self)
        self:PlayUnitSound('CommanderArrival')
		
        self:CreateProjectile( '/effects/entities/UnitTeleport01/UnitTeleport01_proj.bp', 0, 1.35, 0, nil, nil, nil):SetCollision(false)
		self:ShowBone(0, true)
		WaitSeconds(2.1)
        self:SetUnSelectable(false)
        self:SetBusy(false)
        self:SetBlockCommandQueue(false)
        local totalBones = self:GetBoneCount() - 1
        local army = self:GetArmy()
        for k, v in EffectTemplate.UnitTeleportSteam01 do
            for bone = 1, totalBones do
                CreateAttachedEmitter(self,bone,army, v)
            end
        end

        WaitSeconds(6)
        self:SetMesh(self:GetBlueprint().Display.MeshBlueprint, true)
		LOG('Warp ENDE')
		
    end,
	
	
}

TypeClass = UEL0001